<?php

/*
+---------------------------------------------------------------------------
|  UNATCO 1.4 BETA  Invision Power Board Database Convertor
|  ========================================
|  :  ..
|  : drfreddy@mikata.ru
+---------------------------------------------------------------------------
|
|      IPB 2.1.x
|
|    :      14-  2006
|    : 16-  2006
|
+---------------------------------------------------------------------------
*/

class struct_21x
{

  #  get_update_struct  ,      .
  #
  # 1.    .
  # 2.       .
  #    2.1       ,     .
  #    2.2      .     ,  .
  #        2.2.1     ,     .
  #        2.2.2     ,  ,  .
  # 3.     /  ,    .
  #          ,      .
  #
  # 
  # 1.       member_history,    ,   .
  #          . ID ,  ,    mid.
  #          .
  #
  #    :       "members"   "member_history mid".
  #               ,     ID   ,
  #             ""    member_history   mid  ,   
  #                   .
  #
  # 2.       reputation,       .
  #         .  ,    , 
  #     ,    ( added_by),  ,  
  #       ( added_to)      ( rep_id).
  #
  #    :       "members"   "reputation added_by"
  #              "reputation added_to".   ,     ID
  #               , ""    reputation   added_by  added_to  ,
  #                      .
  #              ,     :
  #
  #             "reputation" => array( "reputation rep_id"
  #                                    ),
  #
  #              ,       reputation    
  #             rep_id.       rep_id      
  #               ""  reputation      .

  function get_update_struct() {
    global $UNATCO;

    $struct = array( "admin_logs"      => array( "admin_logs id"
                                                 ),
                     "announcements"   => array( "announcements announce_id"
                                                 ),
                     "attachments"     => array( "attachments attach_id"
                                                 ),
                     "badwords"        => array( "badwords wid"
                                                 ),
                     "banfilters"      => array( "banfilters ban_id"
                                                 ),
                     "bulk_mail"       => array( "bulk_mail mail_id"
                                                 ),
                     "cal_calendars"   => array( "cal_calendars cal_id",
                                                 "cal_events event_calendar_id"
                                                 ),
                     "cal_events"      => array( "cal_events event_id"
                                                 ),
                     "contacts"        => array( "contacts id"
                                                 ),
                     "dnames_change"   => array( "dnames_change dname_id"
                                                 ),
                     "email_logs"      => array( "email_logs email_id"
                                                 ),
                     "forum_perms"     => array( "forum_perms perm_id"
                                                 ),
                     "forum_tracker"   => array( "forum_tracker frid"
                                                 ),
                     "forums"          => array( "forums id",
                                                 "forums parent_id",
                                                 "forum_tracker forum_id",
                                                 "moderator_logs forum_id",
                                                 "moderators forum_id",
                                                 "polls forum_id",
                                                 "topic_mmod topic_move",
                                                 "topic_markers marker_forum_id",
                                                 "topics forum_id",
                                                 "voters forum_id",
                                                 ),
                     "groups"          => array( "groups g_id",
                                                 "members mgroup",
                                                 "validating real_group",
                                                 "validating temp_group"
                                                 ),
                     "mail_error_logs" => array( "mail_error_logs mlog_id"
                                                 ),
                     "mail_queue"      => array( "mail_queue mail_id"
                                                 ),
                     "members"         => array( "members id",
                                                 "admin_logs member_id",
                                                 "admin_permission_rows row_member_id",
                                                 "announcements announce_member_id",
                                                 "attachments attach_member_id",
                                                 "cal_events event_member_id",
                                                 "contacts member_id",
                                                 "contacts contact_id",
                                                 "dnames_change dname_member_id",
                                                 "email_logs from_member_id",
                                                 "email_logs to_member_id",
                                                 "forum_tracker member_id",
                                                 "forums last_poster_id",
                                                 "member_extra id",
                                                 "members_converge converge_id",
                                                 "members_partial partial_member_id",
                                                 "message_topics mt_from_id",
                                                 "message_topics mt_to_id",
                                                 "message_topics mt_owner_id",
                                                 "moderator_logs member_id",
                                                 "moderators member_id",
                                                 "pfields_content member_id",
                                                 "polls starter_id",
                                                 "posts author_id",
                                                 "topics starter_id",
                                                 "topics last_poster_id",
                                                 "topic_markers marker_member_id",
                                                 "topic_ratings rating_member_id",
                                                 "topics_read read_mid",
                                                 "tracker member_id",
                                                 "voters member_id",
                                                 "warn_logs wlog_mid",
                                                 "warn_logs wlog_addedby"
                                                 ),
                     "members_partial" => array( "members_partial partial_id"
                                                 ),
                     "message_text"    => array( "message_text msg_id",
                                                 "message_topics mt_msg_id"
                                                 ),
                     "message_topics"  => array( "message_topics mt_id"
                                                 ),
                     "moderator_logs"  => array( "moderator_logs id"
                                                 ),
                     "moderators"      => array( "moderators mid"
                                                 ),
                     "pfields_data"    => array( "pfields_data pf_id"
                                                 ),
                     "polls"           => array( "polls pid"
                                                 ),
                     "posts"           => array( "posts pid",
                                                 "posts post_parent",
                                                 "topics topic_firstpost",
                                                 "attachments attach_pid"
                                                 ),
                     "topic_mmod"      => array( "topic_mmod mm_id"
                                                 ),
                     "topic_ratings"   => array( "topic_ratings rating_id"
                                                 ),
                     "topics"          => array( "topics tid",
                                                 "forums last_id",
                                                 "polls tid",
                                                 "posts topic_id",
                                                 "topics_read read_tid",
                                                 "topic_ratings rating_tid",
                                                 "tracker topic_id",
                                                 "topic_views views_tid",
                                                 "voters tid"
                                                 ),
                     "tracker"         => array( "tracker trid"
                                                 ),
                     "voters"          => array( "voters vid"
                                                 ),
                     "warn_logs"       => array( "warn_logs wlog_id"
                                                 )
                     );

    return $struct;
  }

  #  get_cache_struct  ,       
  #   .            
  #  (  ,   get_update_struct)    
  #  .
  #
  # 1.     .
  # 2.       ,   .
  #
  #  ,    ,        
  # .     . ,      ,
  #    ,     , 
  #  get_cache_struct   get_pack_struct.
  #
  #  ,             UNATCO
  # (      pfields_content:     ,  
  #           .
  #
  # 
  # 1.       members_lists,     ,   
  #      . ID      (  implode)   mids.
  #
  #    :   ,  ,  "members_list".     
  #                (    ),    
  #                 mids.     mids,   
  #             get_pack_struct (. ).

  function get_cache_struct() {
    global $UNATCO;

    $struct = array( "forum_perms",
                     "forums",
                     "groups",
                     "members",
                     "pfields_data"
                     );

    return $struct;
  }

  #  get_pack_struct  ,      
  #    .      
  #   (. ).
  #
  # 1.    .
  # 2.       .
  #    2.1       ,     .
  #    2.2      .     ,  .
  #        2.2.1     ,     .
  #        2.2.2     ,   ,  .
  #        2.2.3       .
  #              2.2.3.1  "implode",     implode.
  #              2.2.3.2  "serialize",     serialize.
  # 3.     /  ,    .
  #          ,      .
  #
  # 
  # 1.       members_lists,     ,   
  #      . ID      (  implode)   mids.
  #
  #    :       members_list (. ).  
  #               "members",     "members_list mids implode".   
  #                members_list,     mids,  ,    :)
  #                  members.

  function get_pack_struct() {
    global $UNATCO;

    $struct = array( "forum_perms"  => array( "members org_perm_id implode",
                                              "groups g_perm_id implode",
                                              "forums permission_array serialize"
                                             ),
                     "forums"       => array( "announcements announce_forum implode",
                                              "topic_mmod mm_forums implode"
                                              ),
                     "groups"       => array( "members mgroup_others implode"
                                              ),
                     "members"      => array( "members ignored_users implode"
                                              )
                   );

    return $struct;
  }

  #  get_unite_struct  ,       
  #    .
  #
  # 1.    .
  # 2.       .
  #    2.1        ,    
  #          .
  #    2.2        ,       
  #            .
  # 3.     /  ,    .
  #                   
  #     .
  #
  # 
  # 1.      reputation       .
  #     : rep_id (ID  ), added_by ( ), added_to ( ),
  #    text (    ,   ), plus (   ).
  #
  #    :   ,   , :
  #
  #             "reputation" => "rep_id,added_by,added_to,text,plus",
  #
  #                     reputation    
  #               ,  ,     rep_id, added_by, added_to,
  #             text  plus.
  #
  # 2.     forum_perms,       
  #      special_point.
  #
  #    :   ,   "forum_perms",  ",special_signature".  :
  #
  #             "forum_perms" => "perm_id,perm_name,special_signature",
  #
  #              ,       ,    forum_perms
  #                   perm_id  perm_name,    special_signature.
  #

  function get_unite_struct() {
    global $UNATCO;

    $struct = array( "admin_logs"            => "id,act,code,member_id,ctime,note,ip_address",
                     "admin_permission_rows" => "row_member_id,row_perm_cache,row_updated",
                     "announcements"         => "announce_id,announce_title,announce_post,announce_forum,announce_member_id,announce_html_enabled,announce_views,announce_start,announce_end,announce_active",
                     "attachments"           => "attach_id,attach_ext,attach_file,attach_location,attach_thumb_location,attach_thumb_width,attach_thumb_height,attach_is_image,attach_hits,attach_date,attach_temp,attach_pid,attach_post_key,attach_msg,attach_member_id,attach_approved,attach_filesize",
                     "badwords"              => "wid,type,swop,m_exact",
                     "banfilters"            => "ban_id,ban_type,ban_content,ban_date",
                     "bulk_mail"             => "mail_id,mail_subject,mail_content,mail_groups,mail_honor,mail_opts,mail_start,mail_updated,mail_sentto,mail_active,mail_pergo",
                     "cal_calendars"         => "cal_id,cal_title,cal_moderate,cal_position,cal_event_limit,cal_bday_limit,cal_rss_export,cal_rss_export_days,cal_rss_export_max,cal_rss_update,cal_rss_update_last,cal_rss_cache,cal_permissions",
                     "cal_events"            => "event_id,event_calendar_id,event_member_id,event_content,event_title,event_smilies,event_perms,event_private,event_approved,event_unixstamp,event_recurring,event_tz,event_unix_from,event_unix_to",
                     "contacts"              => "id,contact_id,member_id,contact_name,allow_msg,contact_desc",
                     "dnames_change"         => "dname_id,dname_member_id,dname_date,dname_ip_address,dname_previous,dname_current",
                     "email_logs"            => "email_id,email_subject,email_content,email_date,from_member_id,from_email_address,from_ip_address,to_member_id,to_email_address,topic_id",
                     "forum_perms"           => "perm_id,perm_name",
                     "forum_tracker"         => "frid,member_id,forum_id,start_date,last_sent,forum_track_type",
                     "forums"                => "id,topics,posts,last_post,last_poster_id,last_poster_name,name,description,position,use_ibc,use_html,status,password,last_title,last_id,sort_key,sort_order,prune,show_rules,preview_posts,allow_poll,allow_pollbump,inc_postcount,skin_id,parent_id,quick_reply,redirect_url,redirect_on,redirect_hits,redirect_loc,rules_title,rules_text,topic_mm_id,notify_modq_emails,sub_can_post,permission_custom_error,permission_array,permission_showtopic,queued_topics,queued_posts,forum_allow_rating,forum_last_deletion",
                     "groups"                => "g_id,g_view_board,g_mem_info,g_other_topics,g_use_search,g_email_friend,g_invite_friend,g_edit_profile,g_post_new_topics,g_reply_own_topics,g_reply_other_topics,g_edit_posts,g_delete_own_posts,g_open_close_posts,g_delete_own_topics,g_post_polls,g_vote_polls,g_use_pm,g_is_supmod,g_access_cp,g_title,g_can_remove,g_append_edit,g_access_offline,g_avoid_q,g_avoid_flood,g_icon,g_attach_max,g_avatar_upload,g_calendar_post,prefix,suffix,g_max_messages,g_max_mass_pm,g_search_flood,g_edit_cutoff,g_promotion,g_hide_from_list,g_post_closed,g_perm_id,g_photo_max_vars,g_dohtml,g_edit_topic,g_email_limit,g_bypass_badwords,g_can_msg_attach,g_attach_per_post,g_topic_rate_setting,g_dname_changes,g_dname_date",
                     "mail_error_logs"       => "mlog_id,mlog_date,mlog_to,mlog_from,mlog_subject,mlog_content,mlog_msg,mlog_code,mlog_smtp_msg",
                     "mail_queue"            => "mail_id,mail_date,mail_to,mail_from,mail_subject,mail_content,mail_type",
                     "member_extra"          => "id,notes,links,bio,ta_size,photo_type,photo_location,photo_dimensions,aim_name,icq_number,website,yahoo,interests,msnname,vdirs,location,signature,avatar_location,avatar_size,avatar_type",
                     "members"               => "id,name,mgroup,legacy_password,email,joined,ip_address,posts,title,allow_admin_mails,time_offset,hide_email,email_pm,email_full,skin,warn_level,warn_lastwarn,language,last_post,restrict_post,view_sigs,view_img,view_avs,view_pop,bday_day,bday_month,bday_year,new_msg,msg_total,show_popup,misc,last_visit,last_activity,dst_in_use,view_prefs,coppa_user,mod_posts,auto_track,temp_ban,sub_end,login_anonymous,ignored_users,mgroup_others,org_perm_id,member_login_key,subs_pkg_chosen,has_blog,members_markers,members_editor_choice,members_auto_dst,members_display_name,members_created_remote,members_cache,members_disable_pm",
                     "members_partial"       => "partial_id,partial_member_id,partial_date",
                     "members_converge"      => "converge_id,converge_email,converge_joined,converge_pass_hash,converge_pass_salt",
                     "message_text"          => "msg_id,msg_date,msg_post,msg_cc_users,msg_sent_to_count,msg_deleted_count,msg_post_key,msg_author_id,msg_ip_address",
                     "message_topics"        => "mt_id,mt_msg_id,mt_date,mt_title,mt_from_id,mt_to_id,mt_vid_folder,mt_read,mt_hasattach,mt_hide_cc,mt_tracking,mt_owner_id,mt_user_read",
                     "moderator_logs"        => "id,forum_id,topic_id,post_id,member_id,member_name,ip_address,http_referer,ctime,topic_title,action,query_string",
                     "moderators"            => "mid,forum_id,member_name,member_id,edit_post,edit_topic,delete_post,delete_topic,view_ip,open_topic,close_topic,mass_move,mass_prune,move_topic,pin_topic,unpin_topic,post_q,topic_q,allow_warn,edit_user,is_group,group_id,group_name,split_merge,can_mm,mod_can_set_open_time,mod_can_set_close_time",
                     "pfields_content"       => "member_id,updated",
                     "pfields_data"          => "pf_id,pf_title,pf_desc,pf_content,pf_type,pf_not_null,pf_member_hide,pf_max_input,pf_member_edit,pf_position,pf_show_on_reg,pf_input_format,pf_admin_only,pf_topic_format",
                     "polls"                 => "pid,tid,start_date,choices,starter_id,votes,forum_id,poll_question",
                     "posts"                 => "pid,append_edit,edit_time,author_id,author_name,use_sig,use_emo,ip_address,post_date,icon_id,post,queued,topic_id,post_title,new_topic,edit_name,post_key,post_parent,post_htmlstate",
                     "topic_mmod"            => "mm_id,mm_title,mm_enabled,topic_state,topic_pin,topic_move,topic_move_link,topic_title_st,topic_title_end,topic_reply,topic_reply_content,topic_reply_postcount,mm_forums,topic_approve",
                     "topics"                => "tid,title,description,state,posts,starter_id,start_date,last_poster_id,last_post,icon_id,starter_name,last_poster_name,poll_state,last_vote,views,forum_id,approved,author_mode,pinned,moved_to,total_votes,topic_hasattach,topic_firstpost,topic_queuedposts,topic_open_time,topic_close_time,topic_rating_total,topic_rating_hits",
                     "topics_read"           => "read_tid,read_mid,read_date",
                     "topic_ratings"         => "rating_id,rating_tid,rating_member_id,rating_value,rating_ip_address",
                     "topic_views"           => "views_tid",
                     "topic_markers"         => "marker_member_id,marker_forum_id,marker_last_update,marker_unread,marker_topics_read,marker_last_cleared",
                     "tracker"               => "trid,member_id,topic_id,start_date,last_sent,topic_track_type",
                     "validating"            => "vid,member_id,real_group,temp_group,entry_date,coppa_user,lost_pass,new_reg,email_chg,ip_address,user_verified",
                     "voters"                => "vid,ip_address,vote_date,tid,member_id,forum_id",
                     "warn_logs"             => "wlog_id,wlog_mid,wlog_notes,wlog_contact,wlog_contact_content,wlog_date,wlog_type,wlog_addedby"
                     );

    return $struct;
  }

}

?>